const { Plugin } = require("powercord/entities");
const { findInReactTree } = require("powercord/util");
const { getModule, getAllModules, React } = require("powercord/webpack");
const { inject, uninject } = require("powercord/injector");

module.exports = class Sample extends Plugin {
	async startPlugin() { // Called on load

		const d = (m) => {
			const def = m.__powercordOriginal_default ?? m.default
			return typeof def === 'function' ? def : null
		}

		const messageheadermodule = getModule((m) => d(m)?.displayName === "MessageHeader", false)
		



		inject("banana", messageheadermodule, "default", ([props], res) => {
			const { message: { id, author }, subscribeToGroupId } = props;
			if (id !== subscribeToGroupId) {
				return res;
			}


			//children
			const children = res.props.username.props.children[1].props.children
			if (!children || !Array.isArray(children)) {
				return res;
			}

			const tag = React.createElement(
				"h2",
				{
					style: { "display": "inline-block", "margin-left": "5px" },
					key: `ChatUserID-${author.id}`,
				},
				` ${author.id} `
			);

			const pos = "beforebeginfalse"

			const fn = (child) => child && child.key && child.key.startsWith('ChatUserID');
			if (!children.find(fn)) children.splice(pos === 'beforebegin' ? 0 : 2, 0, tag);

			return res;
		});
	}

	pluginWillUnload() {
		uninject("banana");
	}
}
